//+------------------------------------------------------------------+
//|                                                  Ach CheckOrders.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
//            .        . 
//     80  109 .    ,    
//    
//   if(order[6]==0 && order[7]<0) //      (  TP  SL)       
//     {
//      if(OrderDelete(order[8])!=tru)Fun_Error(GetLastError(); //        order[8],           
//      return;  //  OnTick
//     }
//     
extern int Magic=1234;

double buy[5],sell[5],prof[6]; //    
int order[15],order_old[15]; ////   

double L_buy[5],L_sell[5],L_prof[6]; //   
int L_order[15],L_order_old[15]; ////   
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
    CheckOrders(Magic,_Symbol,order,order_old,buy,sell,prof); 

// CheckOrders(Magic,_Symbol,L_order,L_order_old,L_buy,L_sell,L_prof);
   
 //      CheckOrders()
   Comment("Buy      ",order[0],"  ",buy[0],"  ",sell[0],"  ",prof[0],
           "\nSell       ",order[1],"  ",buy[1],"  ",sell[1],"  ",prof[1],
           "\nbuylimit ",order[2],"  ",buy[2],"  ",sell[2],"  ",prof[2],
           "\nselllimit   ",order[3],"  ",buy[3],"  ",sell[3],"  ",prof[3],
           "\nbuystop  ",order[4],"  ",buy[4],"  ",sell[4],"  ",prof[4],
           "\nsellstop  ",order[5],"                            ",prof[5],
           "\n      ",order[6],
           "\n    ",order[7],
           "\n 0 ORD ",order[8],
           "\n ",order[9],
           "\n ",order[10],
           "\n ",order[11],
           "\n ",order[12],
           "\n ",order[13],
           "\n ",order[14]);
  }
void CheckOrders(int Mag,string Symbl,int &orders[15],int &orders_Old[15],double &buy_mas[5],double &sell_mas[5],double &prof_mas[6])
  {

   ArrayCopy(orders_Old,orders);//   

   ArrayInitialize(orders,0);//   
   ArrayInitialize(buy_mas,0);
   ArrayInitialize(sell_mas,0);
   ArrayInitialize(prof_mas,0);//   

/* orders[0] -  Buy
// orders[1] -  Sell
// orders[2] -  buylimit
// orders[3] - selllimit
// orders[4] -  buystop
// orders[5] -  sellstop
// orders[6] -  
// orders[7] -  
// orders[8] -      
// orders[9] -       Buy
// orders[10] -       Buy
// orders[11] -       Sell
// orders[12] -       Sell
// orders[13] -   buylimit  selllimit 
// orders[14] -   buystop   sellstop 

// buy_mas[0] -    Buy    sell_mas[0] -    Sell 
// buy_mas[1] -   NonLosBuy          sell_mas[1] -   NonLosSell 
// buy_mas[2] - max  Buy                      sell_mas[2] - max  Sell
// buy_mas[3] -    Buy             sell_mas[3] -    Sell
// buy_mas[4] -   buy                  sell_mas[4] -   sell

// prof_mas[0] -  Buy    
// prof_mas[1] -  Sell             
// prof_mas[2] -                          
// prof_mas[3] -              
// prof_mas[4] -   
// prof_mas[5] - NoLossTotal              */        


 double techBuy,technSell; //  
   techBuy=0;
   technSell=0;
   int tip;
   int poz;
   int tiket=-1;
   for(poz=OrdersTotal()-1;poz>=0;poz--)
      //+------------------------------------------------------------------+
      //|                                  |
      //+------------------------------------------------------------------+
     {

      if(OrderSelect(poz,SELECT_BY_POS,MODE_TRADES)==true && OrderSymbol()==_Symbol && OrderMagicNumber()==Mag  && OrderTicket()!=tiket)
        {
         tiket=OrderTicket();
         orders[8]=tiket; //     
         tip=OrderType();
         switch(tip)
           {

            case 0:{orders[0]++;orders[6]++;buy_mas[3]+=OrderLots();buy_mas[4]=OrderLots();orders[9]=OrderTicket();break;}
            case 1:{orders[1]++;orders[6]++;sell_mas[3]+=OrderLots();sell_mas[4]=OrderLots();orders[11]=OrderTicket();break;}
            case 2:{orders[2]++;orders[7]++;orders[13]++;break;}
            case 3:{orders[3]++;orders[7]++;orders[13]++;break;}
            case 4:{orders[4]++;orders[7]++;orders[14]++;break;}
            case 5:{orders[5]++;orders[7]++;orders[14]++;break;}
           }
         if(orders[10]<orders[9])orders[10]=orders[9]; //     
         if(orders[12]<orders[11])orders[12]=orders[11];  //     
         if(buy_mas[2]<buy_mas[4])buy_mas[2]=buy_mas[4];  //max  Buy
         if(sell_mas[2]<sell_mas[4])sell_mas[2]=sell_mas[4];  //max  Sell

         if(OrderType()==OP_BUY)
           {

            techBuy=techBuy+OrderOpenPrice()*OrderLots();
            prof_mas[0]=prof_mas[0]+OrderProfit()+OrderSwap(); // Buy  
           buy_mas[1]=NormalizeDouble(techBuy/buy_mas[3],_Digits);  //  NonLosBuy   Swop  
           }

         if(OrderType()==OP_SELL)
           {
            technSell=technSell+OrderOpenPrice()*OrderLots();
            prof_mas[1]=NormalizeDouble(prof_mas[1]+OrderProfit()+OrderSwap(),_Digits);  // Sell 
            sell_mas[1]=NormalizeDouble(technSell/sell_mas[3],_Digits);   //  NonLosSell    Swop  
           }
        }
      if(OrderSelect(poz,SELECT_BY_POS,MODE_TRADES)==true && OrderSymbol()==_Symbol )
        {
         prof_mas[2]=NormalizeDouble(prof_mas[2]+OrderProfit()+OrderSwap(),2);   //     
        }
         if(OrderSelect(poz,SELECT_BY_POS,MODE_TRADES)==true)
        {
         prof_mas[4]=NormalizeDouble(prof_mas[4]+OrderProfit()+OrderSwap(),2);   //    
        }
     }


 if(orders[0]>0 && orders[1]>0 && buy_mas[3]!=sell_mas[3])prof_mas[5]=NormalizeDouble(Bid-prof_mas[2]/MarketInfo(Symbol(),MODE_TICKVALUE)/(buy_mas[3]-sell_mas[3])*Point,Digits); 
   prof_mas[3]=NormalizeDouble(prof_mas[0]+prof_mas[1],2);  //    
   if(OrderSelect(orders[10],SELECT_BY_TICKET,MODE_TRADES)==true)buy_mas[0]=OrderOpenPrice();   //    
   if(OrderSelect(orders[12],SELECT_BY_TICKET,MODE_TRADES)==true)sell_mas[0]=OrderOpenPrice();  //    
   return;
  }
//+------------------------------------------------------------------+